#ifndef _LIBXBEEAPIFRAME_H
#define _LIBXBEEAPIFRAME_H

#include <pic16f688.h> // /usr/share/sdcc/non-free/include/pic14/pic16f648a.h, /usr/share/sdcc/include/pic14/pic16f648a.h
//#include <pic18fregs.h>	// /usr/share/sdcc/include/pic16/pic18f*.h

#define XBEE_START_DLM	0x7E
#define XBEE_XMIT_REQ	0x10
#define XBEE_MODEM_STAT	0x8A
#define XBEE_XMIT_STAT	0x8B
#define XBEE_RECV_PCKT	0x90

/*	XBee		________
			   /		\
			  /			 \
	Vcc		-|1			20|-	AD0/DIO0
	TX		-|2			19|-	AD1/DIO1
	RX		-|3			18|-	AD2/DIO2
	DIO12	-|4			17|-	AD3/DIO3
	RESET	-|5			16|-	RTS/DIO6
	DIO10	-|6			15|-	Assoc./DIO5
	DIO11	-|7			14|-	VREF
			-|8			13|-	ON/SLEEP
	SLEEP_RQ-|9			12|-	CTS/DIO7
	GND		-|10________11|-	DIO4
*/

struct xbee_API_Frame_XMIT_REQ {
	unsigned char sd;							// Start Delimiter
	unsigned char len[2];
	unsigned char type;							// 0x10
	unsigned char id;
	unsigned char dest64[8];					// 64-bit Destination Address
	unsigned char dest16[2];					// 16-bit Destination Network Address
	unsigned char bcrd;							// Broadcast Radius
	unsigned char opts;							// Options
	unsigned char data[255];
};

struct xbee_API_Frame_MODEM_STAT {
	unsigned char sd;							// Start Delimiter
	unsigned char len[2];
	unsigned char type;							// 0x8A
	unsigned char status;						// Status
};

struct xbee_API_Frame_XMIT_STAT {
	unsigned char sd;							// Start Delimiter
	unsigned char len[2];
	unsigned char type;							// 0x8B
	unsigned char id;
	unsigned char dest16[2];					// 16-bit address of destination 
	unsigned char retry;						// Transmit Retry Count 
	unsigned char dlvstat;						// Delivery Status
	unsigned char dscstat;						// Discovery Status
};

struct xbee_API_Frame_RECV_PCKT {
	unsigned char sd;							// Start Delimiter
	unsigned char len[2];
	unsigned char type;							// 0x90
	unsigned char dest64[8];					// 64-bit Source Address
	unsigned char dest16[2];					// 16-bit Source Network Address
	unsigned char opts;							// Receive Options
	unsigned char data[255];
};

extern int xbee_buf_txlen;
extern unsigned char xbee_buf_tx[];
extern unsigned char xbee_buf_rx[];

void xbee_API_Frame_init();
void xbee_API_Frame_puts(unsigned char *s);
void xbee_API_Frame_begin();
void xbee_API_Frame_putc(unsigned char c);
void xbee_API_Frame_end();
unsigned char xbee_API_Frame_receive_rb();

#endif /* _LIBXBEEAPIFRAME_H */

